/* $Id: listitem.gen_h,v 1.35 2001/07/15 13:33:38 murrayc Exp $ */

/* listitem.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/item.h>
#include <gtk/gtklistitem.h>

namespace Gtk {
//: An item in a {\class Gtk::List}.
//- The {\class Gtk::ListItem} widget is used for each item in a {\class Gtk::List}.
class ListItem : public Item {


public:
  typedef ListItem          CppObjectType;
  typedef GtkListItem            BaseObjectType;

public:
  //: Returns the underlaying gtk+ object.
  GtkListItem* gtkobj();
  const GtkListItem* gtkobj() const;

  //: Returns true if object is this type.
  static bool isA(Gtk::Object *object);

  virtual ~ListItem();

private:

public:

  ListItem();
  //: Creates a new {\class Gtk::ListItem} with a child label containing the given string.
  //- label: The string to use for the child label.
  explicit ListItem(const string &label,gfloat x=0.0,gfloat y=0.5);



  // gtk_list_item_(de)select are just a wrapper for gtk_item_(de)select
  // and defined in Gtk_Item, so they do not be redefined here
  // void select();
  // void deselect();





    signal void toggle_focus_row();

    signal void select_all();

    signal void unselect_all();

    signal void undo_selection();

    signal void start_selection();

    signal void end_selection();

    signal void extend_selection(GtkScrollType,gfloat,gboolean);

    signal void scroll_horizontal(GtkScrollType,gfloat);

    signal void scroll_vertical(GtkScrollType,gfloat);

    signal void toggle_add_mode();

protected:
  // impl functions
    virtual void toggle_focus_row_impl();
    virtual void select_all_impl();
    virtual void unselect_all_impl();
    virtual void undo_selection_impl();
    virtual void start_selection_impl();
    virtual void end_selection_impl();
    virtual void extend_selection_impl(GtkScrollType scroll_type,gfloat position,gboolean auto_start_selection);
    virtual void scroll_horizontal_impl(GtkScrollType scroll_type,gfloat position);
    virtual void scroll_vertical_impl(GtkScrollType scroll_type,gfloat position);
    virtual void toggle_add_mode_impl();

};


}
