/* $Id: viewport.gen_h,v 1.44 2000/02/13 02:22:09 kenelson Exp $ */

/* viewport.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/bin.h>
#include <gtk/gtkviewport.h>


namespace Gtk {
class Adjustment;

class Viewport : public Bin {



public:
  typedef Viewport          CppObjectType;
  typedef GtkViewport            BaseObjectType;

public:
  //: Returns the underlaying gtk+ object.
  GtkViewport* gtkobj();
  const GtkViewport* gtkobj() const;

  //: Returns true if object is this type.
  static bool isA(Gtk::Object *object);

  virtual ~Viewport();

private:

public:

    emitable signal void set_scroll_adjustments(Gtk::Adjustment*,Gtk::Adjustment*);

  Viewport();
  Viewport( Adjustment &hadjustment,
	        Adjustment &vadjustment);



  Gtk::Adjustment* get_hadjustment() const;


  Gtk::Adjustment* get_vadjustment() const;

  void set_hadjustment(Gtk::Adjustment* adjustment=0);


  void set_vadjustment(Gtk::Adjustment* adjustment=0);


  void set_hadjustment(Gtk::Adjustment& adjustment);


  void set_vadjustment(Gtk::Adjustment& adjustment);



  GtkShadowType get_shadow_type() const;

  void set_shadow_type(GtkShadowType type);




protected:
  // impl functions
    virtual void set_scroll_adjustments_impl(Gtk::Adjustment* p0,Gtk::Adjustment* p1);

};


//+ PROPERTIES(Gtk_ViewPort)
//. name: shadow_type
//. type: GtkShadowType
//. get:
//. set:
//. desc:

//. name: view_window
//. type: GdkWindow*
//. get:
//. set:
//. desc:

//. name: bin_window
//. type: GdkWindow*
//. get:
//. set:
//. desc:

//. name: hadjustment
//. type: GtkAdjustment*
//. get:
//. set:
//. desc:

//. name: vadjustment
//. type: GtkAdjustment*
//. get:
//. set:
//. desc:

}
